package ro.pub.cs.pp.a51hadoop.algorithm;


/*
 * A generator for Reducer functors that map hash values
 * back to secret values.
 *
 * The actual implementations for the Reducer object may be
 * different.
 */
public interface ReducerGenerator
{

	/*
	 * Generate @length distinct Reducer functors
	 * @length - the number of Reducers to generate
	 * @param  - a parameter to be sent to the reducers
	 *
	 * @return an array of all Reducer objects created
	 */
	public HashReducer[] generate(int length, int param);
}

